#!/bin/sh -eu

f="$1"; shift
t="$1"; shift

exit_handler()
{
	local rc=$1
	rm -rf -- "$TEMPDIR"
	exit $rc
}
trap 'exit 143' HUP INT QUIT TERM
TEMPDIR="$(mktemp -td pam-config-req.XXXXXX)"
trap 'exit_handler $?' EXIT

cd "$TEMPDIR"
tar -xf "$f"

for f in */*; do
	/usr/lib/rpm/pam."$t" "$f"
done |
	sort -u |
	fgrep -v -e ldap.so -e krb5.so -e pkcs11.so |
	tr '\n' ' '
